/*
** Copyright (C) 2000 by Kevin L. Mitchell <klmitch@mit.edu>
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**
** @(#)$Id: ll_add.c,v 1.1 2000/01/27 20:05:52 klmitch Exp $
*/
#include "link.h"
#include "link_int.h"

RCSTAG("@(#)$Id: ll_add.c,v 1.1 2000/01/27 20:05:52 klmitch Exp $");

_l_ul
ll_add(link_head *list, link_elem *element)
{
  if (!ll_verify(list) || !le_verify(element))
    return LINK_ERR_BADARGS;

  if (element->le_prev_p)
    return LINK_ERR_BUSY;

  list->lh_count++;

  element->le_next = list->lh_list;
  element->le_prev_p = &list->lh_list;

  if (list->lh_list)
    list->lh_list->le_prev_p = &element->le_next;
  list->lh_list = element;

  element->le_head = list;

  return 0;
}
